unit ttt_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, DB, DBTables;

type
  TMain = class(TForm)
	Label1: TLabel;
	Label2: TLabel;
	cmbAlias: TComboBox;
	cmbTable: TComboBox;
	Label3: TLabel;
	edtFile: TEdit;
	spdBrowse: TSpeedButton;
	btnCancel: TButton;
    btnAddRecords: TButton;
    dlgBrowse: TOpenDialog;
    tblMain: TTable;
	procedure FormShow(Sender: TObject);
	procedure btnCancelClick(Sender: TObject);
	procedure spdBrowseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure edtFileChange(Sender: TObject);
    procedure cmbAliasChange(Sender: TObject);
    procedure btnAddRecordsClick(Sender: TObject);
  private
	{ Private declarations }
  public
	{ Public declarations }
  end;

var
  Main: TMain;

implementation

{$R *.DFM}

procedure TMain.FormShow(Sender: TObject);
begin
	btnAddRecords.Enabled := (edtFile.Text <> '') and (cmbAlias.ItemIndex <> -1)
		and (cmbTable.ItemIndex <> -1);
end;

procedure TMain.btnCancelClick(Sender: TObject);
begin
	Close;
end;

procedure TMain.spdBrowseClick(Sender: TObject);
begin
	if dlgBrowse.Execute then
		edtFile.Text := dlgBrowse.FileName;
end;

procedure TMain.FormCreate(Sender: TObject);
begin
	Session.ConfigMode := cmAll;
	Session.GetAliasNames(cmbAlias.Items);

end;

procedure TMain.edtFileChange(Sender: TObject);
begin
	btnAddRecords.Enabled := (edtFile.Text <> '') and (cmbAlias.ItemIndex <> -1)
		and (cmbTable.ItemIndex <> -1);
end;

procedure TMain.cmbAliasChange(Sender: TObject);
begin
	Session.GetTableNames(cmbAlias.Items[cmbAlias.ItemIndex],'*.*',True,True,cmbTable.Items);
	edtFileChange(Self);
end;

procedure TMain.btnAddRecordsClick(Sender: TObject);
var
	Records: TStringList;
	I: Integer;
begin
	Screen.Cursor := crHourglass;
	btnAddRecords.Enabled := False;
	btnCancel.Enabled := False;
	try
		Records := TStringList.Create;
		Records.Sorted := True;
		Records.Duplicates := dupIgnore;
		try
			Records.LoadFromFile(edtFile.Text);
		except
			MessageBox(Self.Handle,PChar(Format('Error opening input file %s.',
				[edtFile.Text])),'Error',MB_OK or MB_ICONSTOP);
			Exit;
		end;
		tblMain.DatabaseName := cmbAlias.Items[cmbAlias.ItemIndex];
		tblMain.TableName := cmbTable.Items[cmbTable.ItemIndex];
		try
			tblMain.Open;
		except
			MessageBox(Self.Handle,PChar(Format('Error opening :%s:%s.',[tblMain.DatabaseName,
				tblMain.TableName])),'Error',MB_OK or MB_ICONSTOP);
			Exit;
		end;
		for I := 0 to Records.Count - 1 do
		begin
			try
				tblMain.InsertRecord([Records[I]]);
			except
				MessageBox(Self.Handle,PChar(Format('Error adding records to :%s:%s. %d records were added.',
					[tblMain.DatabaseName,tblMain.TableName,I])),'Error',MB_OK or MB_ICONSTOP);
				Exit;
			end;
		end;
	finally
		Records.Free;
		if tblMain.Active then
			tblMain.Close;
		Screen.Cursor := crDefault;
		btnAddRecords.Enabled := True;
		btnCancel.Enabled := True;
	end;
end;

end.
